﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindRepeater()
        End If
    End Sub

    Private Sub BindRepeater()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("Customers_CRUD")
                cmd.Parameters.AddWithValue("@Action", "SELECT")
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.StoredProcedure
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        Repeater1.DataSource = dt
                        Repeater1.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub Insert(sender As Object, e As EventArgs)
        Dim name As String = txtName.Text
        Dim country As String = txtCountry.Text
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("Customers_CRUD")
                cmd.CommandType = CommandType.StoredProcedure
                cmd.Parameters.AddWithValue("@Action", "INSERT")
                cmd.Parameters.AddWithValue("@Name", name)
                cmd.Parameters.AddWithValue("@Country", country)
                cmd.Connection = con
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
        Me.BindRepeater()
    End Sub

    Protected Sub OnEdit(sender As Object, e As EventArgs)
        'Find the reference of the Repeater Item.
        Dim item As RepeaterItem = TryCast(TryCast(sender, LinkButton).Parent, RepeaterItem)
        Me.ToggleElements(item, True)
    End Sub

    Private Sub ToggleElements(item As RepeaterItem, isEdit As Boolean)
        'Toggle Buttons.
        item.FindControl("lnkEdit").Visible = Not isEdit
        item.FindControl("lnkUpdate").Visible = isEdit
        item.FindControl("lnkCancel").Visible = isEdit
        item.FindControl("lnkDelete").Visible = Not isEdit

        'Toggle Labels.
        item.FindControl("lblContactName").Visible = Not isEdit
        item.FindControl("lblCountry").Visible = Not isEdit

        'Toggle TextBoxes.
        item.FindControl("txtContactName").Visible = isEdit
        item.FindControl("txtCountry").Visible = isEdit
    End Sub

    Protected Sub OnCancel(sender As Object, e As EventArgs)
        'Find the reference of the Repeater Item.
        Dim item As RepeaterItem = TryCast(TryCast(sender, LinkButton).Parent, RepeaterItem)
        Me.ToggleElements(item, False)
    End Sub

    Protected Sub OnUpdate(sender As Object, e As EventArgs)
        'Find the reference of the Repeater Item.
        Dim item As RepeaterItem = TryCast(TryCast(sender, LinkButton).Parent, RepeaterItem)
        Dim customerId As Integer = Integer.Parse(TryCast(item.FindControl("lblCustomerId"), Label).Text)
        Dim name As String = TryCast(item.FindControl("txtContactName"), TextBox).Text.Trim()
        Dim country As String = TryCast(item.FindControl("txtCountry"), TextBox).Text.Trim()

        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("Customers_CRUD")
                cmd.CommandType = CommandType.StoredProcedure
                cmd.Parameters.AddWithValue("@Action", "UPDATE")
                cmd.Parameters.AddWithValue("@CustomerId", customerId)
                cmd.Parameters.AddWithValue("@Name", name)
                cmd.Parameters.AddWithValue("@Country", country)
                cmd.Connection = con
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
        Me.BindRepeater()
    End Sub

    Protected Sub OnDelete(sender As Object, e As EventArgs)
        'Find the reference of the Repeater Item.
        Dim item As RepeaterItem = TryCast(TryCast(sender, LinkButton).Parent, RepeaterItem)
        Dim customerId As Integer = Integer.Parse(TryCast(item.FindControl("lblCustomerId"), Label).Text)

        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("Customers_CRUD")
                cmd.CommandType = CommandType.StoredProcedure
                cmd.Parameters.AddWithValue("@Action", "DELETE")
                cmd.Parameters.AddWithValue("@CustomerId", customerId)
                cmd.Connection = con
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
        Me.BindRepeater()
    End Sub
End Class
